/***
 PhazaSoft littletools 
 Draw arrows and arcs on ChessBomb.com by Phazeus (aka LamLamer)
 For free only!
***/

//Применение Mutation Events является устаревшим. Вместо них используйте MutationObserver.


var arrowsDrawer1 = {};
        // default options
		arrowsDrawer1.options = {
		    base: {
		        canvasZIndex: 10,
		        alertErrors: false,
		        putToContainer: true
		        // + : canvasClass, canvasId    n.r.: ~lazy = false
                // n.r.: redraw-recreate then rescale
		    },
            arrow: {
                connectionType: 'center', // : [rectangleAuto,center,ellipseAuto,side,rectangleAngle,ellipseAngle]  n.r.: ~point, ~centerOffset
                arrowType: 'arrow',              // : [arrow,line,double-headed] n.r.: ~line(or empty), ~bilateralArrow, ~fillArrow
                arrowSize: 9
            },
            render: {
                lineWidth: 'auto', //толщина линий (чило в пикселях или 'auto' для автоматического определения толщины
                strokeStyle: '',
                //lineJoin: 'round'
                // + : another canvas options e.g.: shadowColor: 'rgba(0, 0, 0, 0)', shadowBlur: 0, lineJoin: 'round',
            },
            colors: {
				normal: 'rgba(150, 0, 100, .4)', //обычная линия
				alter: 'rgba(70, 100, 0, .4)', //с нажатым Ctrl
			}, //цвет и прозрачность линий
			widthDivider: 4, //делитель, определяющий толщину стрелки по отношению к толщине ячейки (больше - тоньше)
			arrowheadScale: 1.5, //множитель увеличения кончика стрелки
		};
arrowsDrawer1.options.render.strokeStyle = arrowsDrawer1.options.colors.normal;


const locationToMatch = 'https?://www.chessbomb.com/';
const ignoreFrames = true;

const picture = 'div.ppCBoard'; //элемент, на котором рисовать
const ElementsToWatch = [
'div.ppCBoard-field',
]; //массив элементов для рисования (например, клетки)

let drawElements = {}; //массив данных о текущих элементах
let pkmPressed = false; //нажата левая кнопка
let elDown = null; //элемент, на котором нажали мышь
let elCur = null; //элемент, на котором мышь
let curArrow = null; //элемент текущей стрелки

const {classes: Cc, interfaces: Ci, utils: Cu} = Components;
Cu.import("resource://gre/modules/Services.jsm");
Cu.import("resource://gre/modules/AddonManager.jsm");


function addDiv(theDoc) {
	if (!theDoc) {
		Cu.reportError('no theDoc!');
		//document not provided, it is undefined likely
		return;
	}
	let location = (theDoc.location + '');
	//if (location.toLowerCase().indexOf(locationToMatch) == -1) {
	if (!location.toLowerCase().match(locationToMatch)) {
		return;
	}
	//Cu.reportError('theDoc location matches locationToMatch:' + theDoc.location)
	if (!theDoc instanceof Ci.nsIDOMHTMLDocument) {
		//not html document, so its likely an xul document
		Cu.reportError('theDoc is not an HTML document, it is probably XUL, since i chose to add HTML element, i dont want to add to xul elements, so exit');
		return;
	}
	
	theDoc.documentElement.removeEventListener('DOMSubtreeModified', doWait, false);
	theDoc.documentElement.addEventListener('DOMSubtreeModified', doWait, false);
	
}

function doWait(e) {
	if (e.target.className && e.target.className == 'ppCBoard') {
		if (!e.target.querySelector('canvas.ChessBombDrawing')) {
			e.target.removeEventListener('DOMAttrModified', canvasResize, false);
			e.target.addEventListener('DOMAttrModified', canvasResize, false);
			initDrawer(e.target);
		}
	} //загрузился элемент доски
} //ждём загрузки содержимого с доской

function canvasResize(e) {
	if (e.target === e.currentTarget) {
		let canvases = e.target.querySelectorAll('canvas.ChessBombDrawing');
		if (canvases && canvases.length > 0) {
			for (let canvas of canvases) {
				canvas.height = e.target.style.height.replace(/[^\d]/g, '');
				canvas.width = e.target.style.width.replace(/[^\d]/g, '');
			}
		}
	}
} //изменение размера канвы


function listenPageLoad(event) {
	let win = event.originalTarget.defaultView;
	let doc = win.document;
	if (win.frameElement) {
		//its a frame
		//Cu.reportError('a frame loaded');
		if (ignoreFrames) {
			return;
		}
	}
	addDiv(doc);
}

/*start - windowlistener*/
var windowListener = {
	//DO NOT EDIT HERE
	onOpenWindow: function (aXULWindow) {
		// Wait for the window to finish loading
		let aDOMWindow = aXULWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal || Ci.nsIDOMWindow);
		aDOMWindow.addEventListener('load', function () {
			aDOMWindow.removeEventListener('load', arguments.callee, false);
			windowListener.loadIntoWindow(aDOMWindow, aXULWindow);
		}, false);
	},
	onCloseWindow: function (aXULWindow) {},
	onWindowTitleChange: function (aXULWindow, aNewTitle) {},
	register: function () {
		// Load into any existing windows
		let XULWindows = Services.wm.getXULWindowEnumerator(null);
		while (XULWindows.hasMoreElements()) {
			let aXULWindow = XULWindows.getNext();
			let aDOMWindow = aXULWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal || Ci.nsIDOMWindow);
			windowListener.loadIntoWindow(aDOMWindow, aXULWindow);
		}
		// Listen to new windows
		Services.wm.addListener(windowListener);
	},
	unregister: function () {
		// Unload from any existing windows
		let XULWindows = Services.wm.getXULWindowEnumerator(null);
		while (XULWindows.hasMoreElements()) {
			let aXULWindow = XULWindows.getNext();
			let aDOMWindow = aXULWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal || Ci.nsIDOMWindow);
			windowListener.unloadFromWindow(aDOMWindow, aXULWindow);
		}
		//Stop listening so future added windows dont get this attached
		Services.wm.removeListener(windowListener);
	},
	//END - DO NOT EDIT HERE
	loadIntoWindow: function (aDOMWindow, aXULWindow) {
		if (!aDOMWindow) {
			return;
		}
		if (aDOMWindow.gBrowser) {
			aDOMWindow.gBrowser.addEventListener('DOMContentLoaded', listenPageLoad, false); //TODO
			if (aDOMWindow.gBrowser.tabContainer) {
				//has tabContainer
				//start - go through all tabs in this window we just added to
				let tabs = aDOMWindow.gBrowser.tabContainer.childNodes;
				for (let i = 0; i < tabs.length; i++) {
//					Cu.reportError('DOING tab: ' + i);
					let tabBrowser = tabs[i].linkedBrowser;
					let win = tabBrowser.contentWindow;
					loadIntoContentWindowAndItsFrames(win);
				}
				//end - go through all tabs in this window we just added to
			} else {
				//does not have tabContainer
				let win = aDOMWindow.gBrowser.contentWindow;
				loadIntoContentWindowAndItsFrames(win);
			}
		} else {
			//window does not have gBrowser
		}
	},
	unloadFromWindow: function (aDOMWindow, aXULWindow) {
		if (!aDOMWindow) {
			return;
		}
		if (aDOMWindow.gBrowser) {
			aDOMWindow.gBrowser.removeEventListener('DOMContentLoaded', listenPageLoad, false); //TODO
			if (aDOMWindow.gBrowser.tabContainer) {
				//has tabContainer
				//start - go through all tabs in this window we just added to
				let tabs = aDOMWindow.gBrowser.tabContainer.childNodes;
				for (var i = 0; i < tabs.length; i++) {
//					Cu.reportError('DOING tab: ' + i);
					let tabBrowser = tabs[i].linkedBrowser;
					let win = tabBrowser.contentWindow;
					unloadFromContentWindowAndItsFrames(win);
				}
				//end - go through all tabs in this window we just added to
			} else {
				//does not have tabContainer
				let win = aDOMWindow.gBrowser.contentWindow;
				unloadFromContentWindowAndItsFrames(win);
			}
		} else {
			//window does not have gBrowser
		}
	}
};
/*end - windowlistener*/

function loadIntoContentWindowAndItsFrames(theWin) {
	let frames = theWin.frames;
	let winArr = [theWin];
	for (var j = 0; j < frames.length; j++) {
		winArr.push(frames[j].window);
	}
//	Cu.reportError('# of frames in tab: ' + frames.length);
	for (var j = 0; j < winArr.length; j++) {
		let doc = winArr[j].document;
		//START - edit below here
		addDiv(doc);
		if (ignoreFrames) {
			break;
		}
		//END - edit above here
	}
}

function unloadFromContentWindowAndItsFrames(theWin) {
	let frames = theWin.frames;
	let winArr = [theWin];
	for (var j = 0; j < frames.length; j++) {
		winArr.push(frames[j].window);
	}
//	Cu.reportError('# of frames in tab: ' + frames.length);
	for (var j = 0; j < winArr.length; j++) {
		let doc = winArr[j].document;
		//START - edit below here
		if (ignoreFrames) {
			break;
		}
		//END - edit above here
	}
}

function startup(aData, aReason) {
	windowListener.register();
}

function shutdown(aData, aReason) {
	if (aReason == APP_SHUTDOWN) return;
	if (windowListener) windowListener.unregister();
}

function install(e) {}

function uninstall() {}









function clearDraw(c) {
	curArrow = null;
	elCur = null;
	elDown = null;
	pkmPressed = false;
	for (i in drawElements) {
		if (drawElements[i].arc) {
			if (drawElements[i].arc[0] === c) delete drawElements[i];
		} else if (drawElements[i].arrow) {
			if (drawElements[i].arrow[0] === c) delete drawElements[i];
		}
	}
	arrowsDrawer1.clear(c);
}

function parseEvent(e) {
	e.preventDefault();
	e.stopPropagation();
	if (e.currentTarget.toString() != '[object HTMLDivElement]') return;
	switch(e.type) {
		case 'contextmenu':
		break;
		case 'mousedown':
			pkmPressed = true;
			elDown = e.currentTarget;
			var p = e.currentTarget.closest(picture);
            var c = p.querySelector('canvas.ChessBombDrawing');
            if (c.width != p.scrollWidth) c.width = p.scrollWidth;
            if (c.height != p.scrollHeight) c.height = p.scrollHeight;
			if (e.button == 0) {
				clearDraw(c);
			}
		break;
		case 'mouseup':
			if (e.button != 2) return;
			pkmPressed = false;
			var p = e.currentTarget.closest(picture);
			var c = p.querySelector('canvas.ChessBombDrawing');
			if (e.currentTarget === elDown) { //кружок
				if (c.width != p.scrollWidth) c.width = p.scrollWidth;
				if (c.height != p.scrollHeight) c.height = p.scrollHeight;
				if (drawElements[e.currentTarget.id]) { //стираем кужок
					delete drawElements[e.currentTarget.id];
					arrowsDrawer1.redraw(c);
				} else {
					if (e.metaKey || e.ctrlKey) {
						arrowsDrawer1.options.render.strokeStyle = arrowsDrawer1.options.colors.alter;
					} else {
						arrowsDrawer1.options.render.strokeStyle = arrowsDrawer1.options.colors.normal;
					}
					if (arrowsDrawer1.options.render.lineWidth == 'auto') {
						let radius = (e.currentTarget.offsetWidth > e.currentTarget.offsetHeight) ? e.currentTarget.offsetHeight/arrowsDrawer1.options.widthDivider : e.currentTarget.offsetWidth/arrowsDrawer1.options.widthDivider;
						arrowsDrawer1.options.render.lineWidth = radius;
						arrowsDrawer1.arc(c, e.currentTarget, arrowsDrawer1.options.render.strokeStyle);
						arrowsDrawer1.options.render.lineWidth = 'auto';
					} else {
						arrowsDrawer1.arc(c, e.currentTarget, arrowsDrawer1.options.render.strokeStyle);
					} //определим ширину линии
					drawElements[e.currentTarget.id] = {'arc': [c, e.currentTarget, arrowsDrawer1.options.render.strokeStyle]};
				} //рисуем кружок
			} else { //стрелка
				if (curArrow) {
					if (drawElements[elDown.id + '-' + e.currentTarget.id]) { //стираем стрелку
						delete drawElements[elDown.id + '-' + e.currentTarget.id];
						arrowsDrawer1.redraw(c);
					} else { //запоминаем стрелку
						drawElements[elDown.id + '-' + e.currentTarget.id] = {'arrow': [c, elDown, e.currentTarget, arrowsDrawer1.options.render.strokeStyle]};
					}
				}
			}
			curArrow = null;
			elCur = null;
			elDown = null;
		break;
		case 'mouseenter':
			if (e.buttons != 2 || !pkmPressed || !elDown) return; //только правокнопь
			var p = e.currentTarget.closest(picture);
            var c = p.querySelector('canvas.ChessBombDrawing');
            if (c.width != p.scrollWidth) c.width = p.scrollWidth;
            if (c.height != p.scrollHeight) c.height = p.scrollHeight;
			if (elDown === e.currentTarget && curArrow) { //стираем, перерисовываем
				delete drawElements[elDown.id + '-' + elCur.id];
				arrowsDrawer1.redraw(c);
			} else {
				if (curArrow) {
					curArrow = null;
					arrowsDrawer1.redraw(c);
				}
				if (e.metaKey || e.ctrlKey) {
					arrowsDrawer1.options.render.strokeStyle = arrowsDrawer1.options.colors.alter;
				} else {
					arrowsDrawer1.options.render.strokeStyle = arrowsDrawer1.options.colors.normal;
				}
				if (arrowsDrawer1.options.render.lineWidth == 'auto') {
					let radius = (e.currentTarget.offsetWidth > e.currentTarget.offsetHeight) ? e.currentTarget.offsetHeight/arrowsDrawer1.options.widthDivider : e.currentTarget.offsetWidth/arrowsDrawer1.options.widthDivider;
					arrowsDrawer1.options.render.lineWidth = radius;
					curArrow = arrowsDrawer1.arrow(c, elDown, e.currentTarget, arrowsDrawer1.options.render.strokeStyle);
					arrowsDrawer1.options.render.lineWidth = 'auto';
				} else {
					curArrow = arrowsDrawer1.arrow(c, elDown, e.currentTarget, arrowsDrawer1.options.render.strokeStyle);
				} //определим ширину линии
				elCur = e.currentTarget;
			} //рисуем
		break;
	}
	return;
}

/**************
**************/



    function extend(target, source) {
        if (target != null && source != null) {
            for (name in source) {
                if (source[name] !== undefined) {
                    target[name] = source[name];
                }
            }
        }
        return target;
    }
    function getOffset(canvas, childrenEl) {
        let canv = canvas.getBoundingClientRect(),
            box = childrenEl.getBoundingClientRect();

            return {
                top: box.top - canv.top,
                left: box.left - canv.left,
                width: childrenEl.offsetWidth,
                height: childrenEl.offsetHeight
            };
    }
    function DegToRad(deg){
        return deg * (Math.PI / 180);
    }
    function RadToDeg(deg) {
        return deg * (180 / Math.PI);
    }
    function getSideCoord(coods, side) {
        let x = 0, y = 0;

        switch (side) {
            case 'top':
                x = coods.left + (coods.width / 2);
                y = coods.top;
                break;
            case 'right':
                x = coods.left + coods.width;
                y = coods.top + (coods.height / 2);
                break;
            case 'bottom':
                x = coods.left + (coods.width / 2);
                y = coods.top + coods.height;
                break;
            case 'left':
                x = coods.left;
                y = coods.top + (coods.height / 2);
                break;
            default:    // def: bottom
                x = coods.left + (coods.width / 2);
                y = coods.top + coods.height;
                break;
        }
        return { x: x, y: y }
    }
    function getCenterCoord(coods) {
        return {
            x: coods.left + coods.width / 2,
            y: coods.top + (coods.height / 2)
        }
    }
    function getAngleCoord(r, c, angle) {
        let x, y,
            rAngle = Math.acos(
                Math.sqrt(Math.pow(r.left + r.width - c.x, 2)) /
                Math.sqrt(Math.pow(r.left + r.width - c.x, 2) + Math.pow(r.top - c.y, 2))
                );

        if (angle >= 2 * Math.PI - rAngle || angle < rAngle) {
            x = r.left + r.width;
            y = c.y + Math.tan(angle) * (r.left + r.width - c.x);
        } else
            if (angle >= rAngle && angle < Math.PI- rAngle) {
                x = c.x - ((r.top - c.y) / Math.tan(angle));
                y = r.top + r.height;
            } else
                if (angle >= Math.PI - rAngle && angle < Math.PI + rAngle) {
                    x = r.left;
                    y = c.y - Math.tan(angle) * (r.left + r.width - c.x);
                }
                else
                    if (angle >= Math.PI + rAngle) {
                        x = c.x + ((r.top - c.y) / Math.tan(angle));
                        y = r.top;
                    }
        return {
            x: x,
            y: y
        };
    }
    function getEllipseCoord(r, c, angle) {
        return {
            x: c.x + (r.width / 2) * Math.cos(angle),
            y: c.y + (r.height / 2) * Math.sin(angle)
        };
    }
    function canvasDraw(context, p1, p2, otp) { //fromx, fromy, tox, toy
        let headlen = otp.arrowSize * arrowsDrawer1.options.arrowheadScale;
        let angle = Math.atan2(p2.y - p1.y, p2.x - p1.x);
        context.beginPath();
        context.moveTo(p1.x, p1.y);
        context.lineTo(p2.x, p2.y);

        switch (otp.arrowType) {
            case 'arrow':
                context.moveTo(p2.x - headlen * Math.cos(angle - Math.PI / 6), p2.y - headlen * Math.sin(angle - Math.PI / 6));
                context.lineTo(p2.x, p2.y);
                context.lineTo(p2.x - headlen * Math.cos(angle + Math.PI / 6), p2.y - headlen * Math.sin(angle + Math.PI / 6));
                break;
            case 'line':
                // line already exist
                break;
            case 'double-headed':
                // start
                context.moveTo(p1.x + headlen * Math.cos(angle - Math.PI / 6), p1.y + headlen * Math.sin(angle - Math.PI / 6));
                context.lineTo(p1.x, p1.y);
                context.lineTo(p1.x + headlen * Math.cos(angle + Math.PI / 6), p1.y + headlen * Math.sin(angle + Math.PI / 6));
                // end
                context.moveTo(p2.x - headlen * Math.cos(angle - Math.PI / 6), p2.y - headlen * Math.sin(angle - Math.PI / 6));
                context.lineTo(p2.x, p2.y);
                context.lineTo(p2.x - headlen * Math.cos(angle + Math.PI / 6), p2.y - headlen * Math.sin(angle + Math.PI / 6));

                break;
            default:
                break;
        }
        
        context.stroke();
    }
    
    function canvasDrawArc(context, p, otp, radius) { //x, y
        context.beginPath();
        context.arc(p.x, p.y, radius, 0, 2 * Math.PI);
        context.stroke();
    }
    
    function drawArrow(canvas, div1, div2, style, gRenderOptions, customOptions) {    //, color, lineWidth, shadowColor, shadowBlur , div1side, div2side
		arrowsDrawer1.options.render.strokeStyle = style;
        let context = canvas.getContext('2d'),
            arrowOpt = {},
            dot1 = getOffset(canvas, div1),
            dot2 = getOffset(canvas, div2);

        // extend here with custom
        extend(arrowOpt, arrowsDrawer1.options.arrow);
        extend(context, arrowsDrawer1.options.render);

        if (customOptions !== undefined) {
            if (customOptions.render !== undefined)
                extend(context, customOptions.render);
            if (customOptions.arrow !== undefined)
                extend(arrowOpt, customOptions.arrow);
        }

        switch (arrowOpt.connectionType) {
            case 'rectangleAuto':
                var c1 = getCenterCoord(dot1),
                    c2 = getCenterCoord(dot2);
                dot1 = getAngleCoord(dot1, c1, Math.atan2(c1.y - c2.y, c1.x - c2.x) + Math.PI);
                dot2 = getAngleCoord(dot2, c2, Math.atan2(c2.y - c1.y, c2.x - c1.x) + Math.PI);
                break;
            case 'center':
                dot1 = getCenterCoord(dot1);
                dot2 = getCenterCoord(dot2);
                break;
            case 'ellipseAuto':
                var c1 = getCenterCoord(dot1),
                    c2 = getCenterCoord(dot2);
                dot1 = getEllipseCoord(dot1, c1, Math.atan2(c2.y - c1.y, c2.x - c1.x));
                dot2 = getEllipseCoord(dot2, c2, Math.atan2(c1.y - c2.y, c1.x - c2.x));
                break;
            case 'side':
                dot1 = getSideCoord(dot1, arrowOpt.sideFrom);
                dot2 = getSideCoord(dot2, arrowOpt.sideTo);
                break;
            case 'rectangleAngle':
                dot1 = getAngleCoord(dot1, getCenterCoord(dot1), DegToRad(arrowOpt.angleFrom));
                dot2 = getAngleCoord(dot2, getCenterCoord(dot2), DegToRad(arrowOpt.angleTo));
                break;
            case 'ellipseAngle':
                dot1 = getEllipseCoord(dot1, getCenterCoord(dot1), DegToRad(arrowOpt.angleFrom));
                dot2 = getEllipseCoord(dot2, getCenterCoord(dot2), DegToRad(arrowOpt.angleTo));
                break;
            default: break;
        }
        let radius = (div1.offsetWidth > div1.offsetHeight) ? div1.offsetHeight : div1.offsetWidth;
        if (arrowsDrawer1.options.render.lineWidth == 'auto') {
			arrowsDrawer1.options.render.lineWidth = radius / arrowsDrawer1.options.widthDivider;
			canvasDraw(context, dot1, dot2, arrowOpt);    // - put type of arrow here
			arrowsDrawer1.options.render.lineWidth == 'auto';
		} else {
			canvasDraw(context, dot1, dot2, arrowOpt);    // - put type of arrow here
		}
        
    }
    
    function drawArc(canvas, div, style, gRenderOptions, customOptions) {    //, color, lineWidth, shadowColor, shadowBlur , div1side
		arrowsDrawer1.options.render.strokeStyle = style;
        let context = canvas.getContext('2d'),
            arrowOpt = {},
            dot = getOffset(canvas, div);

        // extend here with custom
        extend(arrowOpt, arrowsDrawer1.options.arrow);
        extend(context, arrowsDrawer1.options.render);

        if (customOptions !== undefined) {
            if (customOptions.render !== undefined)
                extend(context, customOptions.render);
            if (customOptions.arrow !== undefined)
                extend(arrowOpt, customOptions.arrow);
        }

        dot = getCenterCoord(dot);
        
        let radius = (div.offsetWidth > div.offsetHeight) ? div.offsetHeight : div.offsetWidth;
        if (arrowsDrawer1.options.render.lineWidth == 'auto') {
			arrowsDrawer1.options.render.lineWidth = radius / arrowsDrawer1.options.widthDivider;
			canvasDrawArc(context, dot, arrowOpt, radius/2-(arrowsDrawer1.options.render.lineWidth/2));    // - put type of arrow here
			arrowsDrawer1.options.render.lineWidth == 'auto';
		} else {
			canvasDrawArc(context, dot, arrowOpt, radius/2-(arrowsDrawer1.options.render.lineWidth/2));    // - put type of arrow here
		}
    }
    
        arrowsDrawer1.trowException = function (ex) {
            if (arrowsDrawer1.options.base.alertErrors === true)
                console.log('CanvasArrows error: ' + ex);
            throw new Error(ex);
        }
	
        arrowsDrawer1.arrow = function (canvas, from, to, color, customOptions) {
            drawArrow(canvas, from, to, color, arrowsDrawer1.options, customOptions);
            return arrowsDrawer1;
        }
        
        arrowsDrawer1.arrows = function (arrowsArr) {
            for (let i = 0; i < arrowsArr.length; i++) {
                arrowsDrawer1.arrow(arrowsArr[i][0], arrowsArr[i][1], arrowsArr[i][2], arrowsArr[i][3]);
            }
            return arrowsDrawer1;
        }
        
        arrowsDrawer1.arc = function (canvas, on, color, customOptions) {
            drawArc(canvas, on, color, arrowsDrawer1.options, customOptions);
            return arrowsDrawer1;
        }
        
        arrowsDrawer1.clear = function (canvas) {
			try {
				let context = canvas.getContext('2d');
				context.clearRect(0, 0, canvas.width, canvas.height);
			}
			catch(e) {}
            return arrowsDrawer1;
        }
        
		arrowsDrawer1.draw = function (canvas) {
			for (i in drawElements) {
				if (drawElements[i].arc) {
					if (drawElements[i].arc[0] === canvas) {
						arrowsDrawer1.arc(canvas, drawElements[i].arc[1], drawElements[i].arc[2]);
					}
				} else if (drawElements[i].arrow) {
					if (drawElements[i].arrow[0] === canvas) {
						arrowsDrawer1.arrow(canvas, drawElements[i].arrow[1], drawElements[i].arrow[2], drawElements[i].arrow[3]);
					}
				}
			}
			return arrowsDrawer1;
		}
        
        arrowsDrawer1.redraw = function (canvas) {
            return arrowsDrawer1.clear(canvas).draw(canvas);
        }
        
        arrowsDrawer1.updateOptions = function (options) {
            if (options.base !== undefined)
                extend(arrowsDrawer1.options.base, options.base);
            if (options.render !== undefined)
                extend(arrowsDrawer1.options.render, options.render);
            if (options.arrow !== undefined)
                extend(arrowsDrawer1.options.arrow, options.arrow);
            return arrowsDrawer1;
        }


function initDrawer(theDoc) {
	for (let i of ElementsToWatch) {
		let els = theDoc.querySelectorAll(i);
		if (!els || els.length == 0) {
			//console.log('DrawPluginERROR: ' + i + ' element not found.');
			return;
		}
		for (let el of els) {
			el.removeEventListener('contextmenu', parseEvent, false);
			el.addEventListener('contextmenu', parseEvent, false);
			
			el.removeEventListener('mousedown', parseEvent, false);
			el.addEventListener('mousedown', parseEvent, false);
			
			el.removeEventListener('mouseup', parseEvent, false);
			el.addEventListener('mouseup', parseEvent, false);
			
			el.removeEventListener('mouseenter', parseEvent, false);
			el.addEventListener('mouseenter', parseEvent, false);
		}
		
	} //ставим события на элементы клеток
	
		    let canvas = theDoc.ownerDocument.createElement('canvas');
		    canvas.innerHTML = '';
		    canvas.className = 'ChessBombDrawing';
		    canvas.style.position = 'absolute';
		    canvas.style.left = '0px';
		    canvas.style.top = '0px';
		    canvas.style['pointer-events'] = 'none';
		    canvas.style.zIndex = arrowsDrawer1.options.base.canvasZIndex;
		    canvas.width = theDoc.scrollWidth;
		    canvas.height = theDoc.scrollHeight;

		    theDoc.insertBefore(canvas, theDoc.firstChild);
}
